;##################################################################
; DLLAPP
;##################################################################

EXPORT InstallHook

#Include "TBMenuHook.Inc"

.data
	hInstance		DD		0
	hHook			DD		0
	hToolBar		DD		0

;##################################################################

.code

DllEntryPoint	FRAME hInst, reason, reserved1

	mov eax,[reason]
	.DLLPROCESSATTACH
	cmp eax,DLL_PROCESS_ATTACH
	JNE >.DLLPROCESSDETACH
		mov eax,[hInst]
		mov [hInstance], eax
		JMP >.LOAD
	
	.DLLPROCESSDETACH
	cmp eax,DLL_PROCESS_DETACH
	JNE >.DLLTHREADATTACH
		invoke UnhookWindowsHookEx,[hHook]
		JMP >.LOAD
	
	.DLLTHREADATTACH
	cmp eax,DLL_THREAD_ATTACH
	JNE >.DLLTHREADDETACH
		JMP >.LOAD
	
	.DLLTHREADDETACH
	cmp eax,DLL_THREAD_DETACH
	JNE >.NOLOAD
		JMP >.LOAD
	
	.NOLOAD
		xor eax, eax
		ret
	
	.LOAD
		xor eax, eax
		inc eax
		ret

ENDF

InstallHook FRAME hWin

	mov eax,[hWin]
	mov [hToolBar],eax

	invoke SetWindowsHookEx,WH_MSGFILTER,OFFSET MsgHook,[hInstance],0

	mov [hHook],eax
	ret

ENDF

MsgHook FRAME code,wParam,lParam
	uses edi
	LOCAL pt		:POINT
	LOCAL mii		:MENUITEMINFO
	LOCAL pID		:D
	LOCAL rct		:RECT

	mov eax,[code]
	test eax,eax
	js >>.exit

	mov edi,[lParam]
	mov eax,[edi+MSG.message]
	cmp eax, WM_MOUSEMOVE
	jne >>.exit
		invoke GetCursorPos,ADDR pt
		invoke ScreenToClient,[hToolBar],ADDR pt
		mov eax,[pt.y]
		shl eax,16
		mov ecx,[pt.x]
		mov ax,cx
		invoke SendMessage,[hToolBar],WM_MOUSEMOVE,[edi+MSG.wParam],eax
		jmp >>.exit
	.exit

	invoke CallNextHookEx,[hHook],[code],[wParam],[lParam]

	ret

ENDF
